"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getReferenceOrigin = _interopRequireDefault(require("../utils/get-reference-origin"));

var _isFromBabelTypes = _interopRequireDefault(require("../utils/is-from-babel-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  meta: {
    schema: [],
    fixable: "code"
  },

  create(context) {
    return {
      CallExpression(node) {
        const {
          callee
        } = node;
        const scope = context.getScope();
        const origin = (0, _getReferenceOrigin.default)(callee, scope);
        if (!origin) return;
        const {
          name
        } = origin;

        if ((name === "clone" || name === "cloneDeep") && (0, _isFromBabelTypes.default)(origin, scope)) {
          const isMemberExpression = callee.type === "MemberExpression";
          const id = isMemberExpression ? callee.property : callee;
          context.report({
            node: id,
            message: `t.${name}() is deprecated. Use t.cloneNode() instead.`,

            fix(fixer) {
              if (isMemberExpression) {
                return fixer.replaceText(id, "cloneNode");
              }
            }

          });
        }
      }

    };
  }

};
exports.default = _default;