"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _getReferenceOrigin = _interopRequireDefault(require("../utils/get-reference-origin"));

var _isFromBabelTypes = _interopRequireDefault(require("../utils/is-from-babel-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function firstArgumentIsUndefinedString(argumentsArray) {
  return argumentsArray.length > 0 && argumentsArray[0].type === "Literal" && argumentsArray[0].value === "undefined";
}

var _default = {
  meta: {
    schema: []
  },

  create(context) {
    return {
      CallExpression(node) {
        const {
          callee
        } = node;
        const scope = context.getScope();
        const origin = (0, _getReferenceOrigin.default)(callee, scope);
        if (!origin) return;
        const {
          name
        } = origin;

        if ((name === "identifier" || name === "Identifier") && firstArgumentIsUndefinedString(node.arguments) && (0, _isFromBabelTypes.default)(origin, scope)) {
          context.report(node, "Use path.scope.buildUndefinedNode() to create an undefined identifier directly.");
        }
      }

    };
  }

};
exports.default = _default;