"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isBabelPluginFactory;

var _getReferenceOrigin = _interopRequireDefault(require("./get-reference-origin"));

var _getExportName = _interopRequireDefault(require("./get-export-name"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isBabelPluginFactory(node, scope) {
  const {
    parent
  } = node;

  if (parent.type === "CallExpression") {
    const calleeOrigin = (0, _getReferenceOrigin.default)(parent.callee, scope);
    return !!(calleeOrigin && calleeOrigin.kind === "import" && calleeOrigin.name === "declare" && calleeOrigin.source === "@babel/helper-plugin-utils");
  }

  const exportName = (0, _getExportName.default)(node);
  return exportName === "default" || exportName === "module.exports";
}